package errorx

import "gofiber.study.skcks.cn/common/response"

type CodeError struct {
	*response.Response
	Code response.Code `json:"code" example:"500"`
}

type CodeErrorResponse struct {
	*response.Response
}

func NewCustomError(code int, data interface{}, msg string) error {
	return &CodeError{
		Response: response.NewCustomResponse(code, data, msg),
		Code:     code,
	}
}

func NewErrorWithCode(code int, msg string) error {
	return &CodeError{
		Response: response.NewCustomResponse(code, nil, msg),
		Code:     code,
	}
}

func NewDefaultError(msg string) error {
	return NewErrorWithCode(response.ERROR, msg)
}

func (e *CodeError) Error() string {
	return e.Msg
}

func (e *CodeError) Resp() *CodeErrorResponse {
	return &CodeErrorResponse{
		Response: &response.Response{
			Code: e.Code,
			Data: e.Data,
			Msg:  e.Msg,
		},
	}
}
